#
# Copyright 2017 the original author or authors.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#      http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
from enum import Enum

"""
PAS5211 Constants
"""

# from enum PON_true_false_t
PON_FALSE = 0
PON_TRUE = 1

# from enum PON_enable_disable_t
PON_DISABLE = 0
PON_ENABLE = 1

# from enym PON_mac_t
PON_MII = 0
PON_GMII = 1
PON_TBI = 2

PON_POLARITY_ACTIVE_LOW = 0
PON_POLARITY_ACTIVE_HIGH = 1

PON_OPTICS_VOLTAGE_IF_UNDEFINED = 0
PON_OPTICS_VOLTAGE_IF_CML = 1
PON_OPTICS_VOLTAGE_IF_LVPECL = 2

PON_SD_SOURCE_LASER_SD = 0
PON_SD_SOURCE_BCDR_LOCK = 1
PON_SD_SOURCE_BCDR_SD = 2

PON_RESET_TYPE_DELAY_BASED = 0
PON_RESET_TYPE_SINGLE_RESET = 1
PON_RESET_TYPE_DOUBLE_RESET = 2

PON_RESET_TYPE_NORMAL_START_BURST_BASED = 0
PON_RESET_TYPE_NORMAL_END_BURST_BASED = 1

PON_GPIO_LINE_0 = 0
PON_GPIO_LINE_1 = 1
PON_GPIO_LINE_2 = 2
PON_GPIO_LINE_3 = 3
PON_GPIO_LINE_4 = 4
PON_GPIO_LINE_5 = 5
PON_GPIO_LINE_6 = 6
PON_GPIO_LINE_7 = 7
def PON_EXT_GPIO_LINE(line):
    return line + 8

PON_ALARM_SOFTWARE_ERROR = 0
PON_ALARM_LOS = 1
PON_ALARM_LOSI = 2
PON_ALARM_DOWI = 3
PON_ALARM_LOFI = 4
PON_ALARM_RDII = 5
PON_ALARM_LOAMI = 6
PON_ALARM_LCDGI = 7
PON_ALARM_LOAI = 8
PON_ALARM_SDI = 9
PON_ALARM_SFI = 10
PON_ALARM_PEE = 11
PON_ALARM_DGI = 12
PON_ALARM_LOKI = 13
PON_ALARM_TIWI = 14
PON_ALARM_TIA = 15
PON_ALARM_AUTH_FAILED_IN_REGISTRATION_ID_MODE = 20
PON_ALARM_SUFI = 21

PON_DOWNSTREAM_PLOAM_MESSAGE_ENCRYPTED_PORT_ID=8,
PON_DOWNSTREAM_PLOAM_MESSAGE_ASSIGN_ALLOC_ID=10,
PON_DOWNSTREAM_PLOAM_MESSAGE_CONFIGURE_PORT_ID=14,
PON_DOWNSTREAM_PLOAM_MESSAGE_BER_INTERVAL=18,
PON_DOWNSTREAM_PLOAM_MESSAGE_KEY_SWITCHING=19

PON_ALARM_SDI_RAISE=0,
PON_ALARM_SDI_CLEAR=1
PON_ALARM_RAISE=0
PON_ALARM_CLEAR=1

PON_ALARM_VIRTUAL_SCOPE_ONU_LASER_ALWAYS_ON = 16
PON_ALARM_VIRTUAL_SCOPE_ONU_SIGNAL_DEGRADATION = 17
PON_ALARM_VIRTUAL_SCOPE_ONU_EOL = 18
PON_ALARM_VIRTUAL_SCOPE_ONU_EOL_DATABASE_IS_FULL = 19

PON_ALARM_LAST_ALARM = 22

# from enum PON_general_parameters_type_t
PON_COMBINED_LOSI_LOFI = 1000
PON_TX_ENABLE_DEFAULT = 1001

# Enable or disable False queue full event from DBA
PON_FALSE_Q_FULL_EVENT_MODE = 1002

# Set PID_AID_MISMATCH min silence period. 0 - disable, Else - period in secs
PON_PID_AID_MISMATCH_MIN_SILENCE_PERIOD = 1003

# Set if FW generate clear alarm. 0 - generate clear alarm, Else - don't
# generate clear alarm
PON_ENABLE_CLEAR_ALARM = 1004

# Enable or disabl send assign alloc id ploam. 0 - disable, 1 - enable
PON_ASSIGN_ALLOC_ID_PLOAM = 1005

# BIP error polling period, 200 - 65000, 0 - Disabled, Recommended: 5000
# (default)
PON_BIP_ERR_POLLING_PERIOD_MS = 1006

# Ignore SN when decatived 0 - consider SN (deactivate the onu if received
# same SN when activated (default)	1 - Ignore
PON_IGNORE_SN_WHEN_ACTIVE = 1007

# 0xffffffff - Disabled (default). Any other value (0 - 0xfffe) indicates
# that PA delay is enabled, with the specified delay value and included in
# the US_OVERHEAD PLOAM
PON_ONU_PRE_ASSIGNED_DELAY = 1008

# Enable or disable DS fragmentation, 0 disable, 1 enable
PON_DS_FRAGMENTATION = 1009

# Set if fw report rei alarm when errors is 0, 0 disable (default), 1 enable
PON_REI_ERRORS_REPORT_ALL = 1010

# Set if igonre sfi deactivation, 0 disable (default), 1 enable
PON_IGNORE_SFI_DEACTIVATION = 1011

# Allows to override the allocation overhead set by optic-params
# configuration. This configuration is only allowed when the the pon channel
# is disabled
PON_OVERRIDE_ALLOCATION_OVERHEAD = 1012

# Optics timeline offset, -128-127, : this parameter is very sensitive and
# requires coordination with PMC
PON_OPTICS_TIMELINE_OFFSET = 1013

# Last general meter
PON_LAST_GENERAL_PARAMETER = PON_OPTICS_TIMELINE_OFFSET

# from enum PON_dba_mode_t
PON_DBA_MODE_NOT_LOADED = 0
PON_DBA_MODE_LOADED_NOT_RUNNING = 1
PON_DBA_MODE_RUNNING = 2
PON_DBA_MODE_LAST = 3

# from enum type typedef enum PON_port_frame_destination_t
PON_PORT_PON = 0
PON_PORT_SYSTEM = 1

PON_PORT_TYPE_GEM  = 0
PON_PORT_TYPE_TDM  = 1
PON_PORT_TYPE_OMCI = 2

PON_PORT_DESTINATION_CNI0 = 0
PON_PORT_DESTINATION_CNI1 = 1
PON_PORT_DESTINATION_CNI2 = 2
PON_PORT_DESTINATION_CPU  = 3

# from enum PON_olt_hw_classification_t

PON_OLT_HW_CLASSIFICATION_PAUSE = 0
PON_OLT_HW_CLASSIFICATION_LINK_CONSTRAINT = 1
PON_OLT_HW_CLASSIFICATION_IGMP = 2
PON_OLT_HW_CLASSIFICATION_MPCP = 3
PON_OLT_HW_CLASSIFICATION_OAM = 4
PON_OLT_HW_CLASSIFICATION_802_1X = 5
PON_OLT_HW_CLASSIFICATION_PPPOE_DISCOVERY = 6
PON_OLT_HW_CLASSIFICATION_PPPOE_SESSION = 7
PON_OLT_HW_CLASSIFICATION_DHCP_V4 = 8
PON_OLT_HW_CLASSIFICATION_PIM  = 9
PON_OLT_HW_CLASSIFICATION_DHCP_V6 = 10
PON_OLT_HW_CLASSIFICATION_ICMP_V4 = 11
PON_OLT_HW_CLASSIFICATION_MLD = 12
PON_OLT_HW_CLASSIFICATION_ARP = 13
PON_OLT_HW_CLASSIFICATION_CONF_DA = 14
PON_OLT_HW_CLASSIFICATION_CONF_RULE = 15
PON_OLT_HW_CLASSIFICATION_DA_EQ_SA = 16
PON_OLT_HW_CLASSIFICATION_DA_EQ_MAC = 17
PON_OLT_HW_CLASSIFICATION_DA_EQ_SEC_MAC = 18
PON_OLT_HW_CLASSIFICATION_SA_EQ_MAC = 19
PON_OLT_HW_CLASSIFICATION_SA_EQ_SEC_MAC = 20
PON_OLT_HW_CLASSIFICATION_ETHERNET_MANAGEMENT = 100
PON_OLT_HW_CLASSIFICATION_IPV4_LOCAL_MULTICAST = 101
PON_OLT_HW_CLASSIFICATION_IPV4_MANAGEMENT = 102
PON_OLT_HW_CLASSIFICATION_ALL_IPV4_MULTICAST  = 103
PON_OLT_HW_CLASSIFICATION_IPV6_LOCAL_MULTICAST = 104
PON_OLT_HW_CLASSIFICATION_IPV6_MANAGEMENT = 105
PON_OLT_HW_CLASSIFICATION_ALL_IPV6_MULTICAST = 106
PON_OLT_HW_CLASSIFICATION_OTHER	 = 107
PON_OLT_HW_CLASSIFICATION_LAST_RULE  = 108

PON_ACTIVATION_AUTH_AUTO = 0
PON_ACTIVATION_AUTH_HOST_CONTROLLED_SEPARATE_EVENTS = 1 # Host controlled: Separate events
PON_ACTIVATION_AUTH_HOST_CONTROLLED_LUMPED_SN = 2 # Host controlled: Lumped-SN-Response
PON_ACTIVATION_AUTH_REGISTRATION_ID_RAW = 3 # Registration-ID Raw
PON_ACTIVATION_AUTH_REGISTRATION_ID_LEARN = 4  # Registration-ID Learn

PON_LOGICAL_OBJECT_TYPE_ALLOC_ID = 0
PON_LOGICAL_OBJECT_TYPE_ONU_ID_BY_ALLOC_ID  = 1
PON_LOGICAL_OBJECT_TYPE_MAX	= PON_LOGICAL_OBJECT_TYPE_ONU_ID_BY_ALLOC_ID

PMC_OFAL_MAX_BI_DIRECTIONAL_FLOW_PER_ONU = 16
PMC_OFAL_START_FLOW_ID_BASE = 1000

PON_DL_VLAN_SVLAN_REMOVE = 3
PON_DL_VLAN_CVLAN_NO_CHANGE = 0

PON_VLAN_DONT_CHANGE_TAG = 0
PON_VLAN_CHANGE_TAG = 1
PON_VLAN_CHANGE_OTHER_TAG = 2
PON_VLAN_CHANGE_REMOVE_TAG = 3

PON_VLAN_UNUSED_TAG = -1
PON_VLAN_DEST_DATAPATH = 1
PON_VLAN_UNCHANGED_PRIORITY = -1
PON_VLAN_REPLACE_PRIORITY = -2
PON_VLAN_UNUSED_PRIORITY = -1

PON_OUTPUT_VLAN_PRIO_HANDLE_DONT_CHANGE = 0
PON_OUTPUT_VLAN_PRIO_HANDLE_INCOMING_VLAN = 1
PON_OUTPUT_VLAN_PRIO_HANDLE_DL_VLAN_TABLE  = 2

PON_N_TO_1_VLAN_MODE = 0
PON_1_TO_1_VLAN_MODE = 1

# OMCI

OMCI_8021P_MSP_UNMARKED_FRAME_TAG_FRAME = 1
OMCI_8021P_MSP_TP_TYPE_NULL = 0

# GEM interworking option for MAC Bridge LAN
OMCI_GEM_IWTP_IW_OPT_8021P_MAPPER = 5
#LLC frame encapsulation method
OMCI_MAC_BRIDGE_PCD_ENCAP_METHOD_LLC = 1
# Frame Check Sequence will forward
OMCI_MAC_BRIDGE_PCD_LANFCS_FORWARDED = 0
# in DS, perform the inverse of US operation
OMCI_EX_VLAN_TAG_OCD_DS_MODE_US_INVERSE = 0
# Physical path termination point Ethernet UNI
OMCI_EX_VLAN_TAG_OCD_ASSOCIATION_TYPE_PPTP_ETH_UNI = 2

# GEM Port Network CTP

# Direction definitions
GEM_DIR_BIDIRECT = 3 # bi-directional

# PMC
PMC_UPSTREAM_PORT = 129

# SLA

PYTHAGORAS_UPDATE_AID_SLA = 21
PYTHAGORAS_DBA_DATA_COS = 0
PYTHAGORAS_DBA_STATUS_REPORT_NSR = 0
PYTHAGORAS_SET_SLA_RESP_SIZE = 10

# Random values found in PMC code
SLA_gr_bw_gros = 30
SLA_be_bw_gros = 300
SLA_gr_bw_fine = 0
SLA_be_bw_fine = 0

PON_MAX_DS_POLICING_CONFIGURATION_INDEX = 255
PMC_OFAL_NO_POLICY = PON_MAX_DS_POLICING_CONFIGURATION_INDEX+1

#Enum classes to set alarm parameters

class AlarmEventType(Enum):
    COMMUNICATION = 0
    ENVIRONMENT = 1
    EQUIPTMENT = 2
    SERVICE = 3
    PROCESSING = 4
    SECURITY = 5

class AlarmEventCategory(Enum):
    PON = 0

class AlarmEventState(Enum):
    RAISED = 1
    CLEARED = 0

class AlarmEventSeverity(Enum):
    INDETERMINATE = 0
    WARNING = 1
    MINOR = 2
    MAJOR = 3
    CRITICAL = 4

AlarmEventStateDefault = 1

UPSTREAM = 1
DOWNSTREAM = 2

PASCOMM_RETRIES = 5

